//
// Author: 
//   Mikael Hallendal <micke@imendio.com>
//
// (C) 2004 Imendio HB
// 

using GConf;
using Glade;
using Gtk;
using System;

namespace Imendio.Blam {
    public class Preference {
	public static string REVERSE_ENTRIES = Application.GConfBase + "/behaviour/reverse_entries";
    }

    public class PreferencesDialog {
	[Widget] Gtk.Dialog      preferencesDialog;
	[Widget] Gtk.Label       boldBehaviourLabel;
	[Widget] Gtk.CheckButton reverseEntriesCheckButton;
	[Widget] Gtk.Button      closeButton;

	public PreferencesDialog (Gtk.Window parentWindow)
	{
	    Glade.XML gladeXML = Glade.XML.FromAssembly ("blam.glade",
							 "preferencesDialog",
							 null);
	    gladeXML.Autoconnect (this);
	    preferencesDialog.TransientFor = parentWindow;
	    preferencesDialog.Icon = Gdk.Pixbuf.LoadFromResource ("blam.png");

	    boldBehaviourLabel.Markup = "<b>" + boldBehaviourLabel.Text + "</b>";
	    Application.GConfClient.AddNotify (Application.GConfBase, new NotifyEventHandler (ConfNotifyHandler));
	    bool reverseEntries = false;
	    
	    try {
		reverseEntries = (bool) Application.GConfClient.Get (Preference.REVERSE_ENTRIES);
	    } catch {}

	    reverseEntriesCheckButton.Active = reverseEntries;
	}

	public void Show ()
	{
	    preferencesDialog.ShowAll ();
	}

	private void CloseButtonClicked (object obj, EventArgs args)
	{
	    preferencesDialog.Hide();
	}
	
	private void ReverseItemsCheckButtonToggled (object obj, EventArgs args)
	{
	    Application.GConfClient.Set (Preference.REVERSE_ENTRIES, reverseEntriesCheckButton.Active);
	}

	private void ConfNotifyHandler (object sender, NotifyEventArgs args)
	{
	    if (args.Key.Equals (Preference.REVERSE_ENTRIES)) {
		reverseEntriesCheckButton.Active = (bool) args.Value;
	    }
	}
    }
}

