//
// Author:
//   Mario Chavez <>
//
// (C) 2004 Mario Chavez
//

using System;
using System.Net;
using GConf;

namespace Imendio.Blam {
    public class Proxy {

        public Proxy() {}

        public static WebProxy GetProxy()
	{
	    WebProxy proxy = new WebProxy();

	    try {
		bool use_proxy;

		use_proxy = (bool) Application.GConfClient.Get ("/system/http_proxy/use_http_proxy");
		if (use_proxy) {
                    string host;
		    int    port;
		    string proxyUrlString;

		    host = (string) Application.GConfClient.Get ("/system/http_proxy/host");
                    port = (int) Application.GConfClient.Get ("/system/http_proxy/port");

		    proxyUrlString = "http://" + host + ":" + port.ToString();

                    //Console.WriteLine("Using proxy " + proxyUrlString);

                    Uri proxyUrl = new Uri (proxyUrlString);
                    proxy.Address = proxyUrl;

                    string username = (string) Application.GConfClient.Get ("/system/http_proxy/authentication_user");
		    string password = (string) Application.GConfClient.Get ("/system/http_proxy/authentication_password");
                    if (username != null) {
                       proxy.Credentials = new NetworkCredential (username, password);
		    }

		    return proxy;
		} else {
		    return null;
		}
	    } catch(Exception e) {
		return null;
	    }
	}
    }
}
